<?php

//SOME DEFINES
defined('DS') ? null : define('DS', DIRECTORY_SEPARATOR);
defined('WHMCS_MAIN_DIR') ? null : define('WHMCS_MAIN_DIR',
    substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), 'modules' . DS . 'addons')));
//Use module in admin mode
$IS_CLIENTAREA = false;

/**
 * Just change function name. Do not edit anything more.
 */

function HostwindsReseller_config()
{
    //SOME USEFUL STUFF
    require_once dirname(__FILE__) . DS . 'core' . DS . 'functions.php';

    require_once dirname(__FILE__) . DS . 'config.php';

    $module = HostwindsReseller_getModuleClass(__FILE__);
    $MGC = new $module();
    return [
        'name' => $MGC->system_name,
        'description' => $MGC->description,
        'version' => $MGC->version,
        'author' => $MGC->author,
    ];
}

function HostwindsReseller_activate()
{
    //SOME USEFUL STUFF
    require_once dirname(__FILE__) . DS . 'core' . DS . 'functions.php';

    require_once dirname(__FILE__) . DS . 'config.php';

    $module = HostwindsReseller_getModuleClass(__FILE__);
    $MGC = new $module();
    $MGC->activate();
}

function HostwindsReseller_deactivate()
{
    //SOME USEFUL STUFF
    require_once dirname(__FILE__) . DS . 'core' . DS . 'functions.php';

    require_once dirname(__FILE__) . DS . 'config.php';

    $module = HostwindsReseller_getModuleClass(__FILE__);
    $MGC = new $module();
    $MGC->deactivate();
}


function HostwindsReseller_upgrade($vars)
{
    //SOME USEFUL STUFF
    require_once dirname(__FILE__) . DS . 'core' . DS . 'functions.php';

    require_once dirname(__FILE__) . DS . 'config.php';

    $module = HostwindsReseller_getModuleClass(__FILE__);
    $MGC = new $module();
    $MGC->upgrade();
}

/**
 * Admin area output
 * @param type $vars
 */
function HostwindsReseller_output($vars)
{
    require_once dirname(__FILE__) . DS . 'config.php';
    require_once dirname(__FILE__) . DS . 'core' . DS . 'output.php';
}

function HostwindsReseller_clientarea($vars)
{
    //Enable Client Area
    global $IS_CLIENTAREA;
    $IS_CLIENTAREA = true;

    require_once dirname(__FILE__) . DS . 'config.php';
    $content = require_once dirname(__FILE__) . DS . 'core' . DS . 'output_client.php';

    return [
        'pagetitle' => 'HostwindsReseller',
        'breadcrumb' => ['index.php?m=HostwindsReseller' => 'HostwindsReseller'],
        'templatefile' => 'core/base',
        'requirelogin' => isset($_SESSION['uid']) ? false : true,
        'vars' => [
            'content' => $content,
        ],
    ];

}


/**** HELPER ****/
function HostwindsReseller_getModuleClass($file)
{
    $dirname = dirname($file);
    $basename = basename($dirname);
    return $basename;
}

?>
