<?php

if (!defined('WHMCS')) {
    die('This is WHMCS page!');
}
ob_clean();

require_once ADDON_DIR . DS . 'classes' . DS . 'API.php';

try {
    $apiParams = [
        'serverhostname' => $_POST['hostname'],
        'serverusername' => $_POST['email'],
        'serverpassword' => $_POST['password'],
    ];

    //send test connection request
    $api = new API();
    $response = $api->testConnection($apiParams);
    if (!$response['result'] && is_array($response)) {
        throw new Exception($response['msg']);
    }
    if (!is_array($response)) {
        throw new Exception('API does not return JSON response', 500);
    }

    echo json_encode([
        'result' => 'success',
        'messages' => 'Connection established.',
    ]);
    die();
} catch (Exception $exc) {
    echo json_encode([
        'result' => 'error',
        'msg' => $exc->getMessage(),
    ]);
}
die();
