<?php

require_once ADDON_DIR . DS . 'classes' . DS . 'Products.php';
require_once ADDON_DIR . DS . 'core' . DS . 'class.MG_Modules.php';
require_once ADDON_DIR . DS . 'classes' . DS . 'Hostings.php';
require_once ADDON_DIR . DS . 'classes' . DS . 'API.php';

class ServiceSync
{
    private $isSyncDay = false;
    private $api = null;
    private $paramsToSyncs = ['username', 'dedicatedip', 'assignedips'];

    public function __construct()
    {
        $this->api = new API();
        $this->checkSyncWeekDay();
        $this->loadReqiredModulesFiles();
    }

    public function serviceSync($serviceid = false)
    {
        //load all hostwinds products
        $products = new Products();
        $productsIDs = $products->getProductsIds();

        //get all hostwinds RESELLSER services
        $hostings = new Hostings($productsIDs);
        $hostings = $hostings->getHostings();
        //get all hostwinds MAIN services
        $mainWhmcsHostings = [];
        $resellereHostings = [];
        foreach ($hostings as $module => &$resellerModuleHostings) {
            foreach ($resellerModuleHostings as &$resellerHosting) {
                if ($serviceid === false || $serviceid == $resellerHosting) {
                    //create properly obejct for hosting
                    $className = $module . '_Hosting';
                    $resellerHosting = new $className($resellerHosting);
                    $resellereHostings[] = $resellerHosting;
                    //get main whmcs related hosting id
                    if ($resellerHosting->getCustomField('hosting_id') > 0) {
                        $mainWhmcsHostings[] = $resellerHosting->getCustomField('hosting_id');
                    }
                }
            }
        }
        if (!empty($mainWhmcsHostings)) {
            $response = $this->api->getServicesData($mainWhmcsHostings, $this->paramsToSyncs);
            //check if retrice params missmatch with saved reseller hosting data
            foreach ($resellereHostings as $key => &$hostingData) {
                $mainWHMCSHostingID = $hostingData->getCustomField('hosting_id');
                if (key_exists($mainWHMCSHostingID, $response['hostings_ids'])) {
                    $this->updateHostingIfParamsMissMatch($response['hostings_ids'][$mainWHMCSHostingID], $hostingData);
                }
            }
        }
    }

    private function updateHostingIfParamsMissMatch($paramsToCheck, $hostingObj)
    {

        unset($paramsToCheck['id']);
        $toUpdate = [];
        foreach ($paramsToCheck as $param => $value) {
            if ($value != $hostingObj->hosting_details[$param]) {
                $toUpdate[$param] = $value;
            }
        }

        if (!empty($toUpdate)) {
            $hostingObj->updateDetails($toUpdate);
        }
    }

    private function checkSyncWeekDay()
    {
        //send request

        $response = $this->api->getSyncWeekDay();

        if (isset($response['syncWeekDay']) && $response['syncWeekDay'] != null) {
            $syncDay = (int)$response['syncWeekDay'];
            if ($syncDay == (int)date('w')) {
                $this->isSyncDay = true;
            }
        }
    }

    private function loadReqiredModulesFiles()
    {
        $modules = MG_Modules::getSupportedModules();
        foreach ($modules as $module) {
            $moduleDir = ADDON_DIR . DS . '..' . DS . '..' . DS . 'servers' . DS . $module . DS;
            require_once $moduleDir . "class.$module" . '_Hosting.php';
        }
    }
}
