<?php

function HostwindsReseller_getmodule($module_get = false)
{
    if (!$module_get) {
        $serverModulePath = dirname(__FILE__) . DS . '..' . DS . '..' . DS . 'servers' . DS . 'HostwindsReseller' . DS;
    } else {
        if (preg_match('/^[A-Za-z0-9_]+$/i', $module_get)) {
            $serverModulePath = dirname(__FILE__) . DS . '..' . DS . '..' . DS . 'servers' . DS . $module_get . DS;
        } else {
            throw new Exception('Module ' . $module_get . ' is not installed in your whmcs.');
        }
    }
    if (!file_exists($serverModulePath)) {
        throw new Exception('Module ' . $module_get . ' is not installed in your whmcs.');
    }
    if (!file_exists($serverModulePath . 'modules' . DS . 'class.module.php')) {
        throw new Exception('Module HostwindsReseller is not installed in your whmcs.');
    }

    include_once $serverModulePath . 'modules' . DS . 'class.module.php';
    include_once $serverModulePath . 'class.' . $module_get . '_Product.php';
    include_once $serverModulePath . 'class.ApiResponse.php';

    $modules = call_user_func($module_get . '_module::getAllModules');
    if (!isset($modules[0])) {
        throw new Exception('No submodule enabled in HostwindsReseller');
    }

    $submodule = $modules[0];
    $submodulepath = $serverModulePath . 'modules' . DS . $submodule . DS . $submodule . '.php';
    if (!file_exists($submodulepath)) {
        throw new Exception('Module file not found', 403);
    }


    require_once $submodulepath;

    $params = [];
    $api = unserialize(decrypt(getWHMCSconfig('HostwindsResellerServerConfiguration')));
    if (!empty($api)) {
        $params['serverhostname'] = $api['hostname'];
        $params['serverusername'] = $api['email'];
        $params['serverpassword'] = $api['password'];
    }

    $moduleClass = $module_get . '_' . $submodule;
    $module = new $moduleClass();
    $module->params = $params;
    $p_class = $module_get . '_Product';
    $module->product = new $p_class(0);

    return $module;
}
