<?php

use Illuminate\Database\Capsule\Manager as Capsule;

//define addons main dir
defined('ADDON_DIR') ? null : define('ADDON_DIR', dirname(dirname(__FILE__)));

if (!function_exists('encrypt')) {

    function encrypt($string)
    {
        $adminId = Capsule::table('tbladmins')->select('id')->limit(1)->first()->id;
        $result = localAPI('encryptpassword', ['password2' => $string], $adminId);
        return $result['password'];
    }
}

if (!function_exists('decrypt')) {

    function decrypt($string)
    {
        $adminId = Capsule::table('tbladmins')->select('id')->limit(1)->first()->id;
        $result = localAPI('decryptpassword', ['password2' => $string, $adminId]);
        return $result['password'];
    }
}

if (function_exists('mysql_safequery') == false) {
    function mysql_safequery($query, $params = false)
    {
        if ($params) {
            foreach ($params as &$v) {
                $v = mysql_escape_quote_string($v);
            }
            $sql_query = vsprintf(str_replace("?", "%s", $query), $params);
            $sql_query = mysql_run_query($sql_query);
        } else {
            $sql_query = mysql_run_query($query);
        }

        return ($sql_query);
    }
}

if (function_exists('mysql_run_query') == false) {
    function mysql_run_query($query)
    {
        $pdo = Capsule::connection()->getPdo();
        $pdo->beginTransaction();
        try {
            $statement = $pdo->prepare($query);
            $statement->execute();
            global $lastInsertedId;
            $lastInsertedId = $pdo->lastInsertId();
            $pdo->commit();

            return $statement;
            //var_dump(Capsule::connection()->getQueryLog());
            //die();
        } catch (Exception $e) {
            return false;
        }
    }
}
if (function_exists('mysql_extract_assoc') == false) {
    function mysql_extract_assoc($stmt)
    {
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }
}

if (function_exists('mysql_count_rows') == false) {
    function mysql_count_rows($stmt)
    {
        return $stmt->rowCount();
    }
}

if (function_exists('mysql_last_id') == false) {
    function mysql_last_id()
    {
        global $lastInsertedId;
        return (int)$lastInsertedId;
    }
}


if (function_exists('mysql_extract_array') == false) {
    function mysql_extract_array($stmt)
    {
        return $stmt->fetch(PDO::FETCH_BOTH);
    }
}

if (function_exists('mysql_query_safe') == false) {
    /**
     * This is better version of mysql_safequery
     * @param string $query
     * @param array $params
     * @return mysql_query
     * @throws Exception
     */
    function mysql_query_safe($query, array $params = [])
    {
        $pdo = Capsule::connection()->getPdo();
        $pdo->beginTransaction();
        try {
            $statement = $pdo->prepare($query);
            $statement->execute($params);
            global $lastInsertedId;
            $lastInsertedId = $pdo->lastInsertId();
            $pdo->commit();
            return $statement;
            //var_dump(Capsule::connection()->getQueryLog());
            //die();
        } catch (Exception $e) {
            throw $e;
        }
        /*
        if (!empty($params)){
			// there is possibility to use % sign in query - this line escapes it!
			$query = str_replace('%', '%%', $query);

			foreach ($params as $k => $p){
				if ($p === null){
					$query = preg_replace('/\?/', 'NULL', $query, 1);
					unset($params[$k]);
				} elseif (is_int($p) || is_float($p)) {
					$query = preg_replace('/\?/', $p, $query, 1);
					unset($params[$k]);
				} else {
					$query = preg_replace('/\?/', "'%s'", $query, 1);
				}
			}
            foreach ($params as &$v)
				$v = mysql_real_escape_string($v);

            $sql_query = vsprintf( str_replace("?","'%s'",$query), $params );
            $sql_query = mysql_query($sql_query);
        } else {
            $sql_query = mysql_query($query);
        }

		$err = mysql_error();
        if (!$sql_query && $err){
			throw new Exception( $err );
        }
        return ($sql_query);*/
    }
}
if (function_exists('mysql_escape_quote_string') == false) {
    function mysql_escape_quote_string($string)
    {
        return Capsule::connection()->getPdo()->quote($string);
    }
}

if (!function_exists('mysql_get_array')) {
    function mysql_get_array($query, $params = false)
    {
        $q = mysql_safequery($query, $params);
        $arr = [];
        while ($row = mysql_extract_assoc($q)) {
            $arr[] = $row;
        }

        return $arr;
    }
}

if (!function_exists('mysql_get_row')) {
    function mysql_get_row($query, $params = false)
    {
        $q = mysql_safequery($query, $params);
        $row = mysql_extract_assoc($q);
        return $row;
    }
}

if (!function_exists('saveWHMCSconfig')) {
    function saveWHMCSconfig($k, $v)
    {
        $q = mysql_safequery("SELECT `value` FROM tblconfiguration WHERE `setting` = ?", [$k]);
        $ret = mysql_extract_array($q);
        unset($q);

        if (isset($ret['value'])) {
            return mysql_safequery("UPDATE tblconfiguration SET value = ? WHERE setting = ?", [$v, $k]);
        } else {
            return mysql_safequery("INSERT INTO tblconfiguration  (setting,value) VALUES (?,?)", [$k, $v]);
        }
    }
}

if (!function_exists('getWHMCSconfig')) {
    function getWHMCSconfig($k)
    {
        $q = mysql_safequery("SELECT value FROM tblconfiguration WHERE setting = ?", [$k]);
        $ret = mysql_extract_array($q);
        unset($q);

        if ($ret['value']) {
            //load hostname from config.ini file instead from database
            $apiConfig = unserialize(decrypt($ret['value']));
            $ini_array = parse_ini_file(ROOTDIR . DS . 'modules' . DS . 'addons' . DS . 'HostwindsReseller' . DS . 'config.ini');
            $apiConfig = array_merge($apiConfig, $ini_array);

            return encrypt(serialize($apiConfig));
        }
    }
}

if (!function_exists('addError')) {
    function addError($error)
    {
        $_SESSION[ADDON_NAME]['errors'][] = $error;
    }
}


if (!function_exists('addInfo')) {
    function addInfo($info)
    {
        $_SESSION[ADDON_NAME]['infos'][] = $info;
    }
}

if (!function_exists('getErrors')) {
    function getErrors()
    {
        $errors = isset($_SESSION[ADDON_NAME]['errors']) ? $_SESSION[ADDON_NAME]['errors'] : [];
        $_SESSION[ADDON_NAME]['errors'] = null;
        return $errors;
    }
}

if (!function_exists('getInfos')) {
    function getInfos()
    {
        $infos = isset($_SESSION[ADDON_NAME]['infos']) ? $_SESSION[ADDON_NAME]['infos'] : [];
        $_SESSION[ADDON_NAME]['infos'] = null;
        return $infos;
    }
}

if (!function_exists('getAddonUrl')) {
    function getAddonUrl($modpage = null, $modsubpage = null)
    {
        global $IS_CLIENTAREA;
        if ($IS_CLIENTAREA) {
            return 'index.php?m=' . ADDON_NAME . ($modpage ? '&modpage=' . $modpage : '') . ($modsubpage ? '&modsubpage=' . $modsubpage : '');
        } else {
            return 'addonmodules.php?module=' . ADDON_NAME . ($modpage ? '&modpage=' . $modpage : '') . ($modsubpage ? '&modsubpage=' . $modsubpage : '');
        }
    }
}
?>
