<?php


class HostwindsReseller_cpanel_Hosting
{
    //Hosting ID
    public $id = 0;
    //product Detaild
    public $product_details = [];
    //custom fields
    public $custom_fields = [];
    //configurable options
    public $configurable_options = [];

    public function __construct($id)
    {
        $this->id = $id;

        //Load Hosting Params
        $this->load();
    }

    public function updateDetails(array $values)
    {
        $sets = [];
        foreach ($values as $k => $v) {
            $v = is_numeric($v) ? $v : '' . mysql_escape_quote_string($v) . '';
            $sets[] = $k . '=' . $v;

        }

        return mysql_run_query('UPDATE tblhosting SET ' . implode(',', $sets) . ' WHERE id = ' . (int)$this->id);
    }

    public function load()
    {
        //Get Hosting Details
        $q = mysql_get_row("SELECT * FROM tblhosting WHERE id = ?", [$this->id]);
        foreach ($q as $key => &$val) {
            $this->hosting_details[$key] = $val;
        }
        $this->hosting_details['password'] = decrypt($this->hosting_details['password']);

        //Get Custom fields
        $q = mysql_get_array('SELECT cf.id, cf.fieldname, cfv.value
			FROM tblcustomfields AS cf
			JOIN tblcustomfieldsvalues AS cfv ON cfv.fieldid = cf.id
			WHERE cf.type = "product" AND cfv.relid = ' . (int)$this->id . '');
        foreach ($q as $key => &$val) {
            $this->custom_fields[self::getFirstAndLastName($val['fieldname'])] = $val['value'];
        }

        //Get Configurable Options
        $config_options = mysql_get_array('
			SELECT
				co.optionname AS config_option_name,
				cos.optionname AS option_name,
				coh.qty,
				co.optiontype
			FROM tblhostingconfigoptions AS coh
			JOIN tblproductconfigoptions AS co ON coh.configid = co.id
			JOIN tblproductconfigoptionssub AS cos ON cos.id = coh.optionid
			JOIN tblproductconfiggroups AS cog ON cog.id = co.gid
			JOIN tblproductconfiglinks AS col ON cog.id = col.gid
			WHERE
				coh.relid = ? AND
				col.pid = ? AND
                                co.hidden = 0
		', [
            $this->id,
            $this->hosting_details['packageid'],
        ]);

        foreach ($config_options as $key => $val) {
            $this->configurable_options[self::getFirstAndLastName($val['config_option_name'])] = in_array($val['optiontype'],
                [3, 4]) ? $val['qty'] : self::getFirstAndLastName($val['option_name']);
        }
    }

    /********************************
     *          GETTERS
     *******************************/

    /**
     * Get Hosting Details
     * @param type $key
     * @return boolean
     */
    public function getDetails($key = null)
    {
        if (isset($this->hosting_details[$key])) {
            return $this->hosting_details[$key];
        }

        return false;
    }

    /**
     * Get Custom Field
     * @param type $key
     * @return boolean
     */
    public function getCustomField($key)
    {
        if (isset($this->custom_fields[$key])) {
            return $this->custom_fields[$key];
        }

        return false;
    }


    /*******************************
     *           SETTERS
     ******************************/

    public function setDetails($setting, $value)
    {

    }

    /**
     * Set Custom Field
     * @param type $fieldname
     * @param type $value
     */
    public function setCustomField($fieldname, $value)
    {
        $field = mysql_extract_assoc(mysql_query_safe("SELECT `id` FROM tblcustomfields WHERE `type`='Product' AND `relid`=? AND `fieldname` LIKE ?",
            [$this->hosting_details['packageid'], (strpos($fieldname, '|') ? $fieldname . '|%' : $fieldname . '%')]));
        mysql_query_safe('DELETE FROM tblcustomfieldsvalues WHERE fieldid = ? AND relid = ?',
            [$field['id'], $this->id]);
        return mysql_query_safe('INSERT INTO tblcustomfieldsvalues(fieldid,relid,value) VALUES(?,?,?)',
            [$field['id'], $this->id, $value]);

        /*$q = mysql_query_safe("UPDATE tblcustomfields f
            LEFT JOIN tblcustomfieldsvalues v ON f.id = v.fieldid
            SET v.value = ?
            WHERE v.relid = ? AND (f.fieldname = ? OR f.fieldname LIKE ?)", array(
                $value,
                $this->id,
                $fieldname,
                $fieldname.'|%'
            ));*/
    }

    public static function getFirstAndLastName($str, $first = true)
    {
        $pos = strpos($str, '|');
        if ($pos) {
            return $first ? substr($str, 0, $pos) : substr($str, $pos);
        } else {
            return $str;
        }
    }
}
