<?php
define('DS', DIRECTORY_SEPARATOR);
define('WHMCS_MAIN_DIR', ROOTDIR . DS . 'modules' . DS . 'addons');
define('ADDON_DIR',
    WHMCS_MAIN_DIR . DS . 'Hostwinds' . 'Reseller'); //Needs to be 2 string to avoid strepalce for generation
require ADDON_DIR . DS . 'classes' . DS . 'ServiceSync.php';

class HostwindsReseller_cpanel_cpanel extends HostwindsReseller_cpanel_module
{

    public $defaultCustomField = [
        'hosting_id' => ['type' => 'text', 'title' => 'Hosting ID In The Main WHMCS', 'adminonly' => true],
        'ns1' => ['type' => 'text', 'title' => 'Nameserver 1'],
        'ns2' => ['type' => 'text', 'title' => 'Nameserver 2'],
        'ns3' => ['type' => 'text', 'title' => 'Nameserver 3'],
        'ns4' => ['type' => 'text', 'title' => 'Nameserver 4'],
        'nsip1' => ['type' => 'text', 'title' => 'Nameserver 1 IP'],
        'nsip2' => ['type' => 'text', 'title' => 'Nameserver 2 IP'],
        'nsip3' => ['type' => 'text', 'title' => 'Nameserver 3 IP'],
        'nsip4' => ['type' => 'text', 'title' => 'Nameserver 4 IP'],
        'serverip' => ['type' => 'text', 'title' => 'Server IP'],
    ];

    public function getProductsFromSeller()
    {
        return $this->callApi('ProductsList', [
            'module' => 'cpanel',
        ]);
    }

    public function CreateAccount()
    {
        /*if ($this->hosting->getCustomField('hosting_id') && $this->hosting->hosting_details['domainstatus'] != 'Pending') {
            return 'Custom Field /hosting_id/ must be empty to run Create function';
        }*/

        $request = [
            'product_id' => $this->product->getConfig('target_product'),
            'billingcycle' => $this->hosting->hosting_details['billingcycle'],
            'domain' => $this->hosting->hosting_details['domain'],
            'serviceusername' => $this->hosting->hosting_details['username'],
            'servicepassword' => $this->params['password'],
        ];
        //if hosting has hosting id field filled then prevent create action in main
        if ($this->hosting->getCustomField('hosting_id')) {
            $request['preventCreateHosting'] = $this->hosting->getCustomField('hosting_id');
        }

        if ($this->product->type == 'server') {
            $ex_ns1 = explode('.', $this->hosting->hosting_details['ns1']);
            $ex_ns2 = explode('.', $this->hosting->hosting_details['ns2']);
            $ex_domain = explode('.', $this->hosting->hosting_details['domain']);

            $request['hostname'] = $this->hosting->hosting_details['domain'];
            $request['ns1prefix'] = implode('.', array_diff($ex_ns1, $ex_domain));
            $request['ns2prefix'] = implode('.', array_diff($ex_ns2, $ex_domain));
            $request['rootpw'] = $this->params['password'];
        }

        $configoptions = [];
        $prodConfig = $this->product->loadConfig();
        foreach ($prodConfig as $setting => $value) {
            if (substr($setting, 0, 7) == 'confop_') {
                $configoptions[substr($setting, 7)] = $value;
            }
        }
        foreach ($this->hosting->configurable_options as $name => $value) {
            $configoptions[$name] = $value;
        }

        if (!empty($configoptions)) {
            $request['configoptions'] = $configoptions;
        }

        $this->timeout = 30;
        $response = $this->callApi('CreateAccount', $request);
        if ($response->isSuccess()) {
            $this->hosting->setCustomField('hosting_id', $response->json['hosting_id']);

            $update = [];
            if (isset($response->json['username'])) {
                $update['username'] = $response->json['username'];
            }
            if (isset($response->json['password'])) {
                $update['password'] = encrypt($response->json['password']);
            }

            if (isset($response->json['dedicatedip'])) {
                $update['dedicatedip'] = $response->json['dedicatedip'];
            }

            if (isset($response->json['domain'])) {
                $update['domain'] = $response->json['domain'];
            }

            if (isset($response->json['assignedips'])) {
                $update['assignedips'] = $response->json['assignedips'];
            }

            // custom fields
            if (isset($response->json['serverns1'])) {
                $this->hosting->setCustomField('ns1', $response->json['serverns1']);
            }
            if (isset($response->json['serverns2'])) {
                $this->hosting->setCustomField('ns2', $response->json['serverns2']);
            }
            if (isset($response->json['serverns3'])) {
                $this->hosting->setCustomField('ns3', $response->json['serverns3']);
            }
            if (isset($response->json['serverns4'])) {
                $this->hosting->setCustomField('ns4', $response->json['serverns4']);
            }
            if (isset($response->json['servernsip1'])) {
                $this->hosting->setCustomField('nsip1', $response->json['servernsip1']);
            }
            if (isset($response->json['servernsip2'])) {
                $this->hosting->setCustomField('nsip2', $response->json['servernsip2']);
            }
            if (isset($response->json['servernsip3'])) {
                $this->hosting->setCustomField('nsip3', $response->json['servernsip3']);
            }
            if (isset($response->json['servernsip4'])) {
                $this->hosting->setCustomField('nsip4', $response->json['servernsip4']);
            }
            if (isset($response->json['serverip'])) {
                $this->hosting->setCustomField('serverip', $response->json['serverip']);
            }

            if (!empty($update)) {
                $this->hosting->updateDetails($update);
            }

            if ($response->isOrdered() && !$response->isProvisioned()) {
                $sleep = ($this->hosting->hosting_details['domainstatus'] != 'Active') ? 60 : 0;
                $this->StatusSync();
                $response->json['result'] = 0;
            }
        }

        return $response;
    }

    public function TerminateAccount()
    {
        $this->timeout = 30;
        $response = $this->callApi('TerminateAccount', [
            'hosting_id' => $this->hosting->getCustomField('hosting_id'),
        ]);
        if ($response->isSuccess()) {
            $this->hosting->setCustomField('hosting_id', '');
        }

        return $response;
    }

    public function SuspendAccount()
    {
        return $this->callApi('SuspendAccount', [
            'hosting_id' => $this->hosting->getCustomField('hosting_id'),
            'suspendreason' => 'ResellersSuspend',
        ]);
    }

    public function UnsuspendAccount()
    {
        return $this->callApi('UnsuspendAccount', [
            'hosting_id' => $this->hosting->getCustomField('hosting_id'),
        ]);
    }

    public function ChangePassword()
    {
        return $this->callApi('ChangePassword', [
            'hosting_id' => $this->hosting->getCustomField('hosting_id'),
            'servicepassword' => $this->params['password'],
        ]);
    }

    public function ChangePackage()
    {
        if (!$this->hosting->getCustomField('hosting_id')) {
            return 'Custom Field /hosting_id/ is empty';
        }

        $productResponse = $this->callApi('ServicesProduct', [
            'hosting_id' => $this->hosting->getCustomField('hosting_id'),
        ]);

        if ($productResponse->isSuccess()) {

            $request = [
                'hosting_id' => $this->hosting->getCustomField('hosting_id'),
                'serviceid' => $this->hosting->getCustomField('hosting_id'),
                'newproductbillingcycle' => $this->hosting->hosting_details['billingcycle'],
            ];

            if ($productResponse->json['product_id'] != $this->product->getConfig('target_product')) { // PRODUCT UPGRADE

                $request['type'] = 'product';
                $request['newproductid'] = $this->product->getConfig('target_product');

            } else { // CONFIGURABLE OPTIONS UPGRADE

                $request['type'] = 'configoptions';

                $configoptions = [];
                $prodConfig = $this->product->loadConfig();
                foreach ($prodConfig as $setting => $value) {
                    if (substr($setting, 0, 7) == 'confop_') {
                        $configoptions[substr($setting, 7)] = $value;
                    }
                }
                foreach ($this->hosting->configurable_options as $name => $value) {
                    $configoptions[$name] = $value;
                }

                if (!empty($configoptions)) {
                    $request['configoptions'] = $configoptions;
                }

            }

            $response = $this->callApi('ChangePackage', $request);

            if (isset($response->json['assignedips'])) {
                $update['assignedips'] = $response->json['assignedips'];
            }
            if (isset($response->json['dedicatedip'])) {
                $update['dedicatedip'] = $response->json['dedicatedip'];
            }

            if (!empty($update)) {
                $this->hosting->updateDetails($update);
            }

            return $response;

        } else {
            return $productResponse->getMessage();
        }
    }

    public function StatusSync($sleep = 0)
    {
        require_once '..' . DS . 'Hostwinds' . 'Reseller' . 'API' . DS . 'classes' . DS . 'class.Hostwinds' . 'Reseller_Hosting.php';
        require_once '..' . DS . 'Hostwinds' . 'Reseller' . 'API' . DS . 'helpers' . DS . 'WHMCS.php';

        if ($sleep > 0) {
            sleep($sleep);
        }

        if (!$this->hosting->getCustomField('hosting_id')) {
            return 'Custom Field /hosting_id/ is empty';
        }
        $response = $this->callApi('ServicesStatus', [
            'hosting_id' => $this->hosting->getCustomField('hosting_id'),
        ]);

        if ($response->isSuccess()) {

            $serviceSync = new ServiceSync();
            $serviceSync->serviceSync($this->hosting->id);


            $oldServiceStatus = $this->hosting->hosting_details['domainstatus'];
            $mainServiceStatus = $response->json['status'];

            //if mian and reseller's service statuses are different update reseller serivice
            if ($oldServiceStatus != $mainServiceStatus) {
                $update = [
                    'domainstatus' => $mainServiceStatus,
                ];

                $this->hosting->updateDetails($update);
                //if change from Pending to Active send Welcome Email


                if ($oldServiceStatus == 'Pending' && $mainServiceStatus == 'Active') {
                    $class = 'Hostwinds' . 'Reseller_Hosting';
                    $hosting = new $class($this->hosting->getCustomField('hosting_id'));
                    $hosting->sendWelcomeEmail();
                }
            }
        } else {
            return $response->getMessage();
        }

        return 'success';
    }

    public function AdminServicesTabFields()
    {
        $array = [];
        if (!$this->hosting->getCustomField('hosting_id')) {
            $array['Status On The Main WHMCS'] = '<strong style="color:red">No hosting_id. Call Create first!</strong>';
        } else {
            $res = $this->callApi('ServicesStatus', [
                'hosting_id' => $this->hosting->getCustomField('hosting_id'),
            ]);
            if ($res->isSuccess()) {
                $array['Status On The Main WHMCS'] = '<strong style="color:' . ($res->json['status'] == 'Active' ? 'green' : 'red') . '">' . $res->json['status'] . '</strong>';
            } else {
                $array['Status On The Main WHMCS'] = '<strong style="color:red">' . $res->getMessage() . '</strong>';
            }

            $resDetails = $this->callApi('GetClientAreaDetails', [
                'hosting_id' => $this->hosting->getCustomField('hosting_id'),
            ]);
            if ($resDetails->isSuccess()) {
                $array['Manage'] = '
                    <script type="text/javascript">
                        $(document).ready(function(){ 
                            $("#contentarea").append("<form id=\";cPanelLoginForm;\" action=\"' . $resDetails->json['login_link'] . ';\" method=\";post;\" target=\";_blank;\"><input name=\";user;\" value=\";\" type=\";hidden;\"><input name=\";pass;\" type=\";hidden;\"></form>";) 
                            
                            var cPanelUsername = $("input[name=\";username;\"]";).val();
                            var cPanelPassword = $("input[name=\";password;\"]";).val();
                            
                            $("#cPanelLoginForm").find("input[name=\";user;\"]";).val(cPanelUsername);
                            $("#cPanelLoginForm").find("input[name=\";pass;\"]";).val(cPanelPassword);
                            
                            $("#cPanelLoginButton").on("click", function(e){ 
                                e.preventDefault(); 
                                $("#cPanelLoginForm").trigger("submit");
                            });
                        });
                    </script>
                    <button id="cPanelLoginButton" class="btn">
                        Log in to control panel
                    </button>';
            }

        }
        return $array;
    }


    // clientarea.php?action=productdetails&id=ID
    // clientarea.php?action=productdetails&id=ID&modop=custom&a=manage&submodulepage=ACTION
    public function clientarea($params)
    {
        $res = $this->callApi('GetClientAreaDetails', [
            'hosting_id' => $this->hosting->getCustomField('hosting_id'),
        ]);
        if ($res->isSuccess()) {
            return [
                'createEmailAccountURL' => $this->getAjaxUrl('createEmailAccount'),
                'login_link' => $res->json['login_link'],
                'webmail_link' => $res->json['webmail_link'],
                'username' => $params['username'],
                'password' => $params['password'],
            ];
        }
        return [
            'error' => $res->getMessage(),
        ];
    }

    public function clientarea_createEmailAccount($params)
    {
        $res = $this->callApi('CreateEmailAccount', [
            'hosting_id' => $this->hosting->getCustomField('hosting_id'),
            'email_quota' => $params['email_quota'],
            'email_prefix' => $params['email_prefix'],
            'email_pw' => $params['email_pw'],
        ]);
        if ($res->isSuccess()) {
            return [
                'success' => true,
            ];
        }
        return [
            'success' => false,
            'error' => $res->getMessage(),
        ];
    }


    public function UsageUpdate($params)
    {
        $res = $this->callApi('getUsageStats', [
            'hosting_id' => $this->hosting->getCustomField('hosting_id'),
        ]);

        if ($res->isSuccess()) {
            return [
                'success' => true,
                'data' => $res->json['data'],
            ];
        }
        return [
            'success' => false,
            'error' => $res->getMessage(),
        ];
    }

}
